<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FileTxnSnapLog.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.persistence</a> &gt; <span class="el_source">FileTxnSnapLog.java</span></div><h1>FileTxnSnapLog.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.persistence;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.jute.Record;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.KeeperException.Code;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.server.DataTree;
import org.apache.zookeeper.server.DataTree.ProcessTxnResult;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.ZooTrace;
import org.apache.zookeeper.server.persistence.TxnLog.TxnIterator;
import org.apache.zookeeper.txn.CreateSessionTxn;
import org.apache.zookeeper.txn.TxnHeader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This is a helper class 
 * above the implementations 
 * of txnlog and snapshot 
 * classes
 */
public class FileTxnSnapLog {
    //the direcotry containing the 
    //the transaction logs
    private final File dataDir;
    //the directory containing the
    //the snapshot directory
    private final File snapDir;
    private TxnLog txnLog;
    private SnapShot snapLog;
    public final static int VERSION = 2;
    public final static String version = &quot;version-&quot;;
    
<span class="fc" id="L59">    private static final Logger LOG = LoggerFactory.getLogger(FileTxnSnapLog.class);</span>
    
    /**
     * This listener helps
     * the external apis calling
     * restore to gather information
     * while the data is being 
     * restored.
     */
    public interface PlayBackListener {
        void onTxnLoaded(TxnHeader hdr, Record rec);
    }
    
    /**
     * the constructor which takes the datadir and 
     * snapdir.
     * @param dataDir the trasaction directory
     * @param snapDir the snapshot directory
     */
<span class="fc" id="L78">    public FileTxnSnapLog(File dataDir, File snapDir) throws IOException {</span>
<span class="fc" id="L79">        LOG.debug(&quot;Opening datadir:{} snapDir:{}&quot;, dataDir, snapDir);</span>

<span class="fc" id="L81">        this.dataDir = new File(dataDir, version + VERSION);</span>
<span class="fc" id="L82">        this.snapDir = new File(snapDir, version + VERSION);</span>
<span class="fc bfc" id="L83" title="All 2 branches covered.">        if (!this.dataDir.exists()) {</span>
<span class="pc bpc" id="L84" title="1 of 2 branches missed.">            if (!this.dataDir.mkdirs()) {</span>
<span class="nc" id="L85">                throw new IOException(&quot;Unable to create data directory &quot;</span>
                        + this.dataDir);
            }
        }
<span class="fc bfc" id="L89" title="All 2 branches covered.">        if (!this.snapDir.exists()) {</span>
<span class="pc bpc" id="L90" title="1 of 2 branches missed.">            if (!this.snapDir.mkdirs()) {</span>
<span class="nc" id="L91">                throw new IOException(&quot;Unable to create snap directory &quot;</span>
                        + this.snapDir);
            }
        }
<span class="fc" id="L95">        txnLog = new FileTxnLog(this.dataDir);</span>
<span class="fc" id="L96">        snapLog = new FileSnap(this.snapDir);</span>
<span class="fc" id="L97">    }</span>
    
    /**
     * get the datadir used by this filetxn
     * snap log
     * @return the data dir
     */
    public File getDataDir() {
<span class="fc" id="L105">        return this.dataDir;</span>
    }
    
    /**
     * get the snap dir used by this 
     * filetxn snap log
     * @return the snap dir
     */
    public File getSnapDir() {
<span class="fc" id="L114">        return this.snapDir;</span>
    }
    
    /**
     * this function restores the server 
     * database after reading from the 
     * snapshots and transaction logs
     * @param dt the datatree to be restored
     * @param sessions the sessions to be restored
     * @param listener the playback listener to run on the 
     * database restoration
     * @return the highest zxid restored
     * @throws IOException
     */
    public long restore(DataTree dt, Map&lt;Long, Integer&gt; sessions, 
            PlayBackListener listener) throws IOException {
<span class="fc" id="L130">        snapLog.deserialize(dt, sessions);</span>
<span class="fc" id="L131">        FileTxnLog txnLog = new FileTxnLog(dataDir);</span>
<span class="fc" id="L132">        TxnIterator itr = txnLog.read(dt.lastProcessedZxid+1);</span>
<span class="fc" id="L133">        long highestZxid = dt.lastProcessedZxid;</span>
        TxnHeader hdr;
        try {
            while (true) {
                // iterator points to 
                // the first valid txn when initialized
<span class="fc" id="L139">                hdr = itr.getHeader();</span>
<span class="fc bfc" id="L140" title="All 2 branches covered.">                if (hdr == null) {</span>
                    //empty logs 
<span class="fc" id="L142">                    return dt.lastProcessedZxid;</span>
                }
<span class="pc bpc" id="L144" title="3 of 4 branches missed.">                if (hdr.getZxid() &lt; highestZxid &amp;&amp; highestZxid != 0) {</span>
<span class="nc" id="L145">                    LOG.error(&quot;{}(higestZxid) &gt; {}(next log) for type {}&quot;,</span>
<span class="nc" id="L146">                            new Object[] { highestZxid, hdr.getZxid(),</span>
<span class="nc" id="L147">                                    hdr.getType() });</span>
                } else {
<span class="fc" id="L149">                    highestZxid = hdr.getZxid();</span>
                }
                try {
<span class="fc" id="L152">                    processTransaction(hdr,dt,sessions, itr.getTxn());</span>
<span class="nc" id="L153">                } catch(KeeperException.NoNodeException e) {</span>
<span class="nc" id="L154">                   throw new IOException(&quot;Failed to process transaction type: &quot; +</span>
<span class="nc" id="L155">                         hdr.getType() + &quot; error: &quot; + e.getMessage(), e);</span>
<span class="fc" id="L156">                }</span>
<span class="fc" id="L157">                listener.onTxnLoaded(hdr, itr.getTxn());</span>
<span class="fc bfc" id="L158" title="All 2 branches covered.">                if (!itr.next()) </span>
<span class="fc" id="L159">                    break;</span>
            }
<span class="fc" id="L161">        } finally {</span>
<span class="fc" id="L162">            if (itr != null) {</span>
<span class="pc bpc" id="L163" title="2 of 4 branches missed.">                itr.close();</span>
            }
<span class="fc" id="L165">        }</span>
<span class="pc bpc" id="L166" title="1 of 2 branches missed.">        return highestZxid;</span>
    }
    
    /**
     * process the transaction on the datatree
     * @param hdr the hdr of the transaction
     * @param dt the datatree to apply transaction to
     * @param sessions the sessions to be restored
     * @param txn the transaction to be applied
     */
    public void processTransaction(TxnHeader hdr,DataTree dt,
            Map&lt;Long, Integer&gt; sessions, Record txn)
        throws KeeperException.NoNodeException {
        ProcessTxnResult rc;
<span class="fc bfc" id="L180" title="All 3 branches covered.">        switch (hdr.getType()) {</span>
        case OpCode.createSession:
<span class="fc" id="L182">            sessions.put(hdr.getClientId(),</span>
<span class="fc" id="L183">                    ((CreateSessionTxn) txn).getTimeOut());</span>
<span class="pc bpc" id="L184" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L185">                ZooTrace.logTraceMessage(LOG,ZooTrace.SESSION_TRACE_MASK,</span>
                        &quot;playLog --- create session in log: 0x&quot;
<span class="nc" id="L187">                                + Long.toHexString(hdr.getClientId())</span>
                                + &quot; with timeout: &quot;
<span class="nc" id="L189">                                + ((CreateSessionTxn) txn).getTimeOut());</span>
            }
            // give dataTree a chance to sync its lastProcessedZxid
<span class="fc" id="L192">            rc = dt.processTxn(hdr, txn);</span>
<span class="fc" id="L193">            break;</span>
        case OpCode.closeSession:
<span class="fc" id="L195">            sessions.remove(hdr.getClientId());</span>
<span class="pc bpc" id="L196" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L197">                ZooTrace.logTraceMessage(LOG,ZooTrace.SESSION_TRACE_MASK,</span>
                        &quot;playLog --- close session in log: 0x&quot;
<span class="nc" id="L199">                                + Long.toHexString(hdr.getClientId()));</span>
            }
<span class="fc" id="L201">            rc = dt.processTxn(hdr, txn);</span>
<span class="fc" id="L202">            break;</span>
        default:
<span class="fc" id="L204">            rc = dt.processTxn(hdr, txn);</span>
        }

        /**
         * Snapshots are lazily created. So when a snapshot is in progress,
         * there is a chance for later transactions to make into the
         * snapshot. Then when the snapshot is restored, NONODE/NODEEXISTS
         * errors could occur. It should be safe to ignore these.
         */
<span class="fc bfc" id="L213" title="All 2 branches covered.">        if (rc.err != Code.OK.intValue()) {</span>
<span class="fc" id="L214">            LOG.debug(&quot;Ignoring processTxn failure hdr:&quot; + hdr.getType()</span>
                    + &quot;, error: &quot; + rc.err + &quot;, path: &quot; + rc.path);
        }
<span class="fc" id="L217">    }</span>

    /**
     * the last logged zxid on the transaction logs
     * @return the last logged zxid
     */
    public long getLastLoggedZxid() {
<span class="nc" id="L224">        FileTxnLog txnLog = new FileTxnLog(dataDir);</span>
<span class="nc" id="L225">        return txnLog.getLastLoggedZxid();</span>
    }

    /**
     * save the datatree and the sessions into a snapshot
     * @param dataTree the datatree to be serialized onto disk
     * @param sessionsWithTimeouts the sesssion timeouts to be
     * serialized onto disk
     * @throws IOException
     */
    public void save(DataTree dataTree,
            ConcurrentHashMap&lt;Long, Integer&gt; sessionsWithTimeouts)
        throws IOException {
<span class="fc" id="L238">        long lastZxid = dataTree.lastProcessedZxid;</span>
<span class="fc" id="L239">        File snapshotFile = new File(snapDir, Util.makeSnapshotName(lastZxid));</span>
<span class="fc" id="L240">        LOG.info(&quot;Snapshotting: 0x{} to {}&quot;, Long.toHexString(lastZxid),</span>
                snapshotFile);
<span class="fc" id="L242">        snapLog.serialize(dataTree, sessionsWithTimeouts, snapshotFile);</span>
        
<span class="fc" id="L244">    }</span>

    /**
     * truncate the transaction logs the zxid
     * specified
     * @param zxid the zxid to truncate the logs to
     * @return true if able to truncate the log, false if not
     * @throws IOException
     */
    public boolean truncateLog(long zxid) throws IOException {
        // close the existing txnLog and snapLog
<span class="fc" id="L255">        close();</span>

        // truncate it
<span class="fc" id="L258">        FileTxnLog truncLog = new FileTxnLog(dataDir);</span>
<span class="fc" id="L259">        boolean truncated = truncLog.truncate(zxid);</span>
<span class="fc" id="L260">        truncLog.close();</span>

        // re-open the txnLog and snapLog
        // I'd rather just close/reopen this object itself, however that 
        // would have a big impact outside ZKDatabase as there are other
        // objects holding a reference to this object.
<span class="fc" id="L266">        txnLog = new FileTxnLog(dataDir);</span>
<span class="fc" id="L267">        snapLog = new FileSnap(snapDir);</span>

<span class="fc" id="L269">        return truncated;</span>
    }
    
    /**
     * the most recent snapshot in the snapshot
     * directory
     * @return the file that contains the most 
     * recent snapshot
     * @throws IOException
     */
    public File findMostRecentSnapshot() throws IOException {
<span class="fc" id="L280">        FileSnap snaplog = new FileSnap(snapDir);</span>
<span class="fc" id="L281">        return snaplog.findMostRecentSnapshot();</span>
    }
    
    /**
     * the n most recent snapshots
     * @param n the number of recent snapshots
     * @return the list of n most recent snapshots, with
     * the most recent in front
     * @throws IOException
     */
    public List&lt;File&gt; findNRecentSnapshots(int n) throws IOException {
<span class="fc" id="L292">        FileSnap snaplog = new FileSnap(snapDir);</span>
<span class="fc" id="L293">        return snaplog.findNRecentSnapshots(n);</span>
    }

    /**
     * get the snapshot logs that are greater than
     * the given zxid 
     * @param zxid the zxid that contains logs greater than 
     * zxid
     * @return
     */
    public File[] getSnapshotLogs(long zxid) {
<span class="nc" id="L304">        return FileTxnLog.getLogFiles(dataDir.listFiles(), zxid);</span>
    }

    /**
     * append the request to the transaction logs
     * @param si the request to be appended
     * returns true iff something appended, otw false 
     * @throws IOException
     */
    public boolean append(Request si) throws IOException {
<span class="fc" id="L314">        return txnLog.append(si.hdr, si.txn);</span>
    }

    /**
     * commit the transaction of logs
     * @throws IOException
     */
    public void commit() throws IOException {
<span class="fc" id="L322">        txnLog.commit();</span>
<span class="fc" id="L323">    }</span>

    /**
     * roll the transaction logs
     * @throws IOException 
     */
    public void rollLog() throws IOException {
<span class="fc" id="L330">        txnLog.rollLog();</span>
<span class="fc" id="L331">    }</span>
    
    /**
     * close the transaction log files
     * @throws IOException
     */
    public void close() throws IOException {
<span class="fc" id="L338">        txnLog.close();</span>
<span class="fc" id="L339">        snapLog.close();</span>
<span class="fc" id="L340">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>